Registers a User Defined Function for use as a collating function in SQL statements

- « PDO::sqliteCreateAggregate

- PDO::sqliteCreateFunction »

- PHP Manual
- SQLite (PDO)
- Registers a User Defined Function for use as a collating function in SQL statements

# PDO::sqliteCreateCollation

(PHP 5 >= 5.3.11, PHP 7, PHP 8)

PDO::sqliteCreateCollation — Registers a User Defined Function for use as a collating function in SQL statements

### Description

public PDO::sqliteCreateCollation(string `$name`, callable `$callback`): bool
Warning

This function is EXPERIMENTAL. The behaviour of this function, its name, and surrounding documentation may change without notice in a future release of PHP. This function should be used at your own risk.

### Parameters

`name`

  Name of the SQL collating function to be created or redefined.

`callback`

  The name of a PHP function or user-defined function to apply as a callback, defining the behavior of the collation. It should accept two strings and return as strcmp() does, i.e. it should return -1, 1, or 0 if the first string sorts before, sorts after, or is equal to the second.

  This function need to be defined as:

  collation(string `$string1`, string `$string2`): int

### Return Values

Returns `true` on success or `false` on failure.

### Examples

Example #1 PDO::sqliteCreateCollation() example

    <?php$db = new PDO('sqlite::memory:');$db->exec("CREATE TABLE test (col1 string)");$db->exec("INSERT INTO test VALUES ('a1')");$db->exec("INSERT INTO test VALUES ('a10')");$db->exec("INSERT INTO test VALUES ('a2')");$db->sqliteCreateCollation('NATURAL_CMP', 'strnatcmp');foreach ($db->query("SELECT col1 FROM test ORDER BY col1") as $row) {  echo $row['col1'] . "\n";}echo "\n";foreach ($db->query("SELECT col1 FROM test ORDER BY col1 COLLATE NATURAL_CMP") as $row) {  echo $row['col1'] . "\n";}?>

The above example will output:

    a1
    a10
    a2

    a1
    a2
    a10